program Project1;

{$APPTYPE CONSOLE}

uses
  SysUtils {: CoClass},
  ActiveX,
  VisaComLib_TLB in 'c:\program files\borland\bds\4.0\Imports\VisaComLib_TLB.pas'; // This path may need to change depending on how you get the VISA COM type info
  var rm : IResourceManager3;
  var io : IMessage;
  var sess : IVisaSession;
  var retCount : Integer;
  var readResult : WideString;
begin
  CoInitializeEx (NIL, COINIT_APARTMENTTHREADED);  // Start COM on this thread
  rm := CoResourceManager.Create;  // Create the VISA COM I/O Resource manager
  rm.Open('GPIB0::23::INSTR', NO_LOCK, 0, '', sess); // Use the resource manager to create a VISA COM Session
  sess.QueryInterface(IID_IMessage, io); // The IVisaSession interface is very general and does not have string reading/writing , we want to be able to read and write to the instrument
  io.WriteString('*IDN?', retCount); // Write to the instrument
  io.ReadString(1000, readResult); // read the result
  sess := nil; // cause Delphi to release the COM objects before the program closes to avoid leaked resources and errors
  io.Close(); // ...
  rm := nil; // ...
  Writeln(readResult); // Write the result to the console
  Readln(readResult); // Read from the console so that the program just doesn't disappear
end.
